function [n,dn,intw,intcoord,detj]=ele_s(ielem,coord,top,mat,shp,intcoord,idet);
%
% input: 
%   ielem    : element number
%   coord    : nodal coordinates
%   

if (nargin<6), intcoord=[]; end
if (nargin<7), idet=[]; end

if isempty(ielem), ielem=1; end

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype]=sysinfo(size(coord),size(top));
imat     = top(ielem,iimat);

shfunction = shp(1);
intrule    = shp(2);
nint       = shp(3);

nsd        = 2;

if length(shp)==4,
   nsd=shp(4);
end

detj=[]; intw=[];

if (intrule==1 & isempty(intcoord)),
   [intw,intcoord]=gauss(nint,nsd);
elseif (intrule==2 & isempty(intcoord)),
   [intw,intcoord]=gausstri(nint); intw=intw/2;
elseif (intrule==3 & isempty(intcoord));
   [intw,intcoord]=gaussl(nint,nsd);
end

[n,dn]=shape(intcoord,shfunction);

if ~isempty(idet),
   [nnodes,nsd,nelem,maxnlnodes,iimat,iitype]=sysinfo(size(coord),size(top));
   nlnodes  = length(nonzeros(top(ielem,1:maxnlnodes)));
   nodcoord=coord(top(ielem,1:nlnodes),:);
   nint=length(intcoord(:,1));
   detj=zeros(1,nint);
   for int=1:nint
       [dndxy,detj(int)]=getderiv(dn,nodcoord,int);
   end
end


