function elmdat=int2elm(intdat,coord,top,mat);
%
% elmdat=int2elm(intdat,coord,top,mat);
%

if nargin<6,
   struct=[];
end

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype] = sysinfo(size(coord),size(top));

nlnodes=maxnlnodes;
par=eleminfo(1,[],top,mat,7);
nint=par(1); nvar=par(2); nmode=par(3);
elmdat=zeros(nelem,nlnodes,nvar,nmode);

for ielem=1:nelem
   
   par=eleminfo(ielem,[],top,mat,7);
   
   if ~isempty(par),
      nint=par(1); nvar=par(2); nmode=par(3);
      
      imat    = top(ielem,iimat);
      
      etop = top(ielem,:);
      gshp = eleminfo(1,[],etop,mat,4);
      ng   = elemshp(1,[],etop,mat,gshp);
      
      [vpos,vshp] = eleminfo(1,[],top,mat,5);
      [n,dn,intworg,intcoord] = elemshp(1,[],etop,mat,vshp(1,:));
      nint=length(intworg);
      
      
      % make a linear projection
      n=elemshp(1,[],etop,mat,[23 2 nint]);
      [n,dn,intw] = elemshp(1,[],etop,mat,[23 2 nint]);
      
      nodcoord=zeros(nlnodes,2);
      nodcoord(:,1)=coord(top(ielem,1:nlnodes),1);
      nodcoord(:,2)=coord(top(ielem,1:nlnodes),2);
      
      eintdat=reshape(intdat(ielem,:),nint,nvar,nmode);
      
      qp=zeros(3,3);
      rhse=zeros(3,nvar,nmode);
      for int=1:nint
         
         qp=qp+n(int,:)'*n(int,:)*intw(int);
         for ivar=1:nvar
            for imode=1:nmode
               rhse(:,ivar,imode)=rhse(:,ivar,imode) + n(int,:)'*eintdat(int,ivar,imode)*intw(int);
            end
         end
      end
      
      
      nlnodes=length(ng(1,:));
      eintdat=reshape(intdat(ielem,:),nint,nvar,nmode);
      
      ksinodes=eleminfo(ielem,coord,top,mat,6);
      [n] = elemshp(1,[],etop,mat,[23 2 nint],ksinodes);
      
      for ivar=1:nvar
         for imode=1:nmode
            sol  = qp \ rhse(:,ivar,imode);
            elmdat(ielem,1:nlnodes,ivar,imode)=n*sol;
         end
      end
      
   end
   
end
