function elmdat=int2elm_e(ielem,intdat,coord,top,mat);
%
% elmdat=int2elm_e(ielem,intdat,coord,top,mat);
%
% make a projection of the integration point data of a triangular element
% (quadratic of linear) onto a linear interpolation, but compute it for all the
% nodes of the element.

if nargin<6,
   struct=[];
end

% retrieve size information
[nnodes,nsd,nelem,maxnlnodes,iimat,iitype] = sysinfo(size(coord),size(top));

% get the number of nodes
nlnodes=maxnlnodes;
par=eleminfo(1,[],top,mat,7);
nint=par(1); nvar=par(2); nmode=par(3);

% initialize the element data of this particular element
elmdat=zeros(nlnodes,nvar,nmode);


%for ielem=1:nelem

%par=eleminfo(ielem,[],top,mat,7);
ddof=eleminfo(ielem,[],top,mat,2);

par=size(intdat);

if ~isempty(par),
   %nint=par(1); nvar=par(2); nmode=par(3);
   
   nint=par(1); nvar=par(2); 
   if length(par)>=3, nmode=par(3); end
   
   imat    = top(ielem,iimat);
   
   etop = top(ielem,:);
   gshp = eleminfo(1,[],etop,mat,4);
   ng   = elemshp(1,[],etop,mat,gshp);
   
   [vpos,vshp] = eleminfo(1,[],top,mat,5);
   [n,dn,intworg,intcoord] = elemshp(1,[],etop,mat,vshp(1,:));
   nint=length(intworg);
   
   % make a linear projection
   if vshp(1,2)==1,
      [n,dn,intw]=elemshp(1,[],etop,mat,[14 1 sqrt(nint)]);
   elseif vshp(1,2)==2,
      [n,dn,intw]=elemshp(1,[],etop,mat,[23 2 nint]);
   end
      
   %n=elemshp(1,[],etop,mat,[23 2 nint]);
   %[n,dn,intw] = elemshp(1,[],etop,mat,[23 2 nint]);
   
   nodcoord=zeros(nlnodes,2);
   nodcoord(:,1)=coord(top(ielem,1:nlnodes),1);
   nodcoord(:,2)=coord(top(ielem,1:nlnodes),2);
   
   %eintdat=reshape(intdat(ielem,:),nint,nvar,nmode);
   eintdat=intdat;
   
   ndofp=length(n(1,:));
   qp=zeros(ndofp,ndofp);
   rhse=zeros(ndofp,nvar,nmode);
   for int=1:nint
      
      qp=qp+n(int,:)'*n(int,:)*intw(int);
      for ivar=1:nvar
         for imode=1:nmode
            rhse(:,ivar,imode)=rhse(:,ivar,imode) + n(int,:)'*eintdat(int,ivar,imode)*intw(int);
         end
      end
   end
   
   
   nlnodes=length(ng(1,:));
   %eintdat=reshape(intdat(ielem,:),nint,nvar,nmode);
   eintdat=intdat;
   
   ksinodes=eleminfo(ielem,coord,top,mat,6);
   % make a linear projection
   if vshp(1,2)==1,
      [n]=elemshp(1,[],etop,mat,[14 1 sqrt(nint)],ksinodes);
   elseif vshp(1,2)==2,
      [n]=elemshp(1,[],etop,mat,[23 2 nint],ksinodes);
   end
      
   %[n] = elemshp(1,[],etop,mat,[23 2 nint],ksinodes);
   
   for ivar=1:nvar
      for imode=1:nmode
         sol  = qp \ rhse(:,ivar,imode);
         elmdat(1:nlnodes,ivar,imode)=n*sol;
      end
   end
   
end

%end
