function [x]=innmdxdy(m,bias,lx,x0,ichois,lxa,nea);
%
%
% calling sequence:
%
% [x]=innmdxdy(m,bias,lx,x0,ichois,lxa,nea);
%
% ichois = 1: dx(n)=bias*dx(1)
%          2: dx(i)=bias*dx(i-1)
%          5: dx(1)=bias
%

if (ichois==1),
bias=abs(bias);
if (m == 1),
   dx1=lx;
else
   sumx=0;
   for j=1:m
       sumx=sumx+((bias-1)/(m-1))*j+(m-bias)/(m-1);
   end
   dx1=lx/(sumx);
end
x=zeros(m+1,1);
x(1)=x0;
for j=1:m
    if (m == 1),
        x(2)=x(1)+dx1;
    else
        dx= ( (bias-1)/(m-1)*j+(m-bias)/(m-1) )*dx1;
        x(j+1)=x(j)+dx;
    end
end

elseif (ichois==2),

bias=abs(bias);
if (m==1),
   dx1=lx;
else
   sumx=0;
   for j=1:m
       sumx=sumx+bias^(j-1);
   end
   dx1=lx/sumx;
end
x=zeros(m+1,1);
x(1)=x0;
for j=1:m
    if (m==1),
       x(2)=dx1;
    else
       dx=bias^(j-1)*dx1;
       x(j+1)=x(j)+dx;
    end
end

elseif (ichois==3),

bias0=sign(bias);
if (m==1),
   dx1=lx;
else
   dx1=bias0*bias;
   sumx1=0; sumx2=0;
   for j=1:m
       sumx1=sumx1+(j-1)/(m-1);
       sumx2=sumx2+1-(j-1)/(m-1);
   end
   dxm=(lx-sumx2*dx1)/sumx1;
end
x=zeros(m+1,1);
if (bias0>0);
    x(1)=x0;
else 
    x(1)=x0;
    a=dxm;
    dxm=dx1;
    dx1=a;
end


for j=1:m
    if (m==1),
       x(2)=dx1;
    else
       dx=(j-1)/(m-1)*dxm+(1-(j-1)/(m-1))*dx1;
       x(j+1)=x(j)+dx;
    end
end

elseif (ichois==4),
   
   bias0=sign(bias);
   lx1=lxa;
   lx2=lx-lxa;
   m1=nea;
   m2=m-m1;

   dx1=bias0*bias;
   x(1)=x0;
   sumx1=0; sumx2=0;
   for j=1:m1
       sumx1=sumx1+(j-1)/(m1-1);
       sumx2=sumx2+1-(j-1)/(m1-1);
   end

   dxm=(lx1-sumx2*dx1)/sumx1;

   if (bias0>0);
    x(1)=x0;
   else 
    x(1)=x0;
    a=dxm;
    dxm=dx1;
    dx1=a;
   end


   for j=1:m1
       dx=(j-1)/(m1-1)*dxm+(1-(j-1)/(m1-1))*dx1;
       x(j+1)=x(j)+dx;
   end

   dx1=dxm;
   sumx1=0; sumx2=0;
   for j=1:m2
       sumx1=sumx1+(j-1)/(m2-1);
       sumx2=sumx2+1-(j-1)/(m2-1);
   end

   dxm=(lx2-sumx2*dx1)/sumx1;

   if (bias0<0);
    a=dxm;
    dxm=dx1;
    dx1=a;
   end


   for j=1:m2
       dx=(j-1)/(m2-1)*dxm+(1-(j-1)/(m2-1))*dx1;
       x(m1+j+1)=x(m1+j)+dx;
   end


elseif (ichois==5),

    if (m==1),
       x(1)=x0;
       x(2)=x0+lx;
    else
       bias0=sign(bias);
       ii=ones(1,m-1);
       dx1=bias0*bias;
       f=roots([ii 1-lx/dx1]);
       i=find(imag(f)==0);
       j=min(find(f(i)>0));
       i=i(j); f=f(i);
       if (bias0<0),
         dx1=f^(m-1)*bias0*bias;
         f=1/f;
       end
       x=zeros(m+1,1);
       x(1)=x0;
       dx=dx1;
       for j=1:m
           dx=f^(j-1)*dx1;
           x(j+1)=x(j)+dx;
       end
    end


elseif (ichois==6),


bias0=sign(bias);
m=m/2;
if (m==1),
   dx1=lx;
else
   dx1=bias0*bias;
   sumx1=0; sumx2=0;
   for j=1:m
       sumx1=sumx1+(j-1)/(m-1);
       sumx2=sumx2+1-(j-1)/(m-1);
   end
   dxm=(lx-sumx2*dx1)/sumx1;
end
x=zeros(m+1,1);
if (bias0>0);
    x(1)=x0;
else 
    x(1)=x0;
    a=dxm;
    dxm=dx1;
    dx1=a;
end


for j=1:m
    if (m==1),
       x(2)=dx1;
    else
       dx=(j-1)/(m-1)*dxm+(1-(j-1)/(m-1))*dx1;
       x(j+1)=x(j)+dx;
    end
end

x0=x;
x(1:2:2*m+1)=x0;
x(2:2:2*m)=x(1:2:2*m)+diff(x0)./2;

elseif (ichois==7),

m=m/2;
   bias0=sign(bias);
   ii=ones(1,m-1);
   dx1=bias0*bias;
   f=roots([ii 1-lx/dx1]);
   i=find(imag(f)==0);
   j=min(find(f(i)>0));
   i=i(j); f=f(i);
   if (bias0<0),
      dx1=f^(m-1)*bias0*bias;
      f=1/f;
   end
   x=zeros(m+1,1);
   x(1)=x0;
   dx=dx1;
   for j=1:m
    if (m==1),
       x(2)=dx1;
    else
       dx=f^(j-1)*dx1;
       x(j+1)=x(j)+dx;
    end

   end
x0=x;
x(1:2:2*m+1)=x0;
x(2:2:2*m)=x(1:2:2*m)+diff(x0)./2;



   
end

