function [top,coord,toporg,coordorg,bndcon,index,topp,...
          usercurves,usercurvesorg,topbnd]=...
          trimesh(top,coord,ichois,bndcon,origin,usercurves,userpoints,topbnd,iopt)
%
%[top,coord,toporg,coordorg,bndcon,index,topp,...
% usercurves,usercurvesorg,topbnd]=...
%        trimesh(top,coord,ichois,bndcon,origin,usercurves,userpoints,topbnd,iopt);
%
% 
% transforms a quadrilateral element mesh to a triangular element mesh
%
% if (nlnodes==3),				% linear triangle > extended linear triangle
% if (nlnodes==4 & iopt==0),	% linear quad		> linear triangle
% if (nlnodes==4 & iopt==1),	% linear quad		> extended linear triangle
% if (nlnodes==9 & iopt==0),	% quadra. quad		> quadra. triangle
% if (nlnodes==9 & iopt==1),	% quadra. quad		> extended quadra. triangle
% 


if (nargin==5), 
   origin=[0;0];
   iopt=0;
end
if (nargin==7),
   iopt=0;
end

if (nargin==6),
   topbnd=[];
   iopt=0;
end

% copy original topology and coordinates

toporg=top; coordorg=coord; usercurvesorg=usercurves;

[nnodes,nsd,nelem,nlnodes,iimat,iitype] = sysinfo(size(coord),size(top));

%nelem   = length(top(:,1));
%nlnodes = length(top(1,:))-1;
%nnodes  = length(coord(:,1));

topp=[];

if (nlnodes==3),						% linear triangle > extended linear triangle
   toptr = zeros(nelem,5);
elseif (nlnodes==4 & iopt==0),	% linear quad		> linear triangle
   toptr = zeros(nelem*2,4);
elseif (nlnodes==4 & iopt==1),	% linear quad		> extended linear triangle
   toptr = zeros(nelem*2,5);
elseif (nlnodes==9 & iopt==1),	% quadra. quad		> extended quadra. triangle
   toptr = zeros(nelem*2,8);
elseif (nlnodes==9 & iopt==0),	% quadra. quad		> quadra. triangle
   toptr = zeros(nelem*2,7);	
elseif (nlnodes==6),
   toptr = zeros(nelem*4,5);
   topp  = zeros(nelem*4,4);
end

if iopt==1,
   coordtr=zeros(nnodes+nelem,2);
else
   coordtr=coord;
end

if (nlnodes==3 & iopt==1),
   coordtr=zeros(nnodes+4*nelem,2);
end
coordtr(1:nnodes,:)=coord;

kelem=0;
for ielem=1:nelem
    nodes=top(ielem,1:nlnodes);

    if (nlnodes==3 & iopt==1),

       map=[1 2; 2 3; 3 1];
% create additional midpoint node
       coordtr(nnodes+ielem,:)=[sum(coord(nodes,1))/3  ...
                                sum(coord(nodes,2))/3];
       for i=1:3
           kelem=kelem+1;
           knodes=[nodes(map(i,:)) nnodes+ielem];
           toptr(kelem,:)=[knodes nnodes+nelem+kelem top(ielem,nlnodes+1)];
           coordtr(nnodes+nelem+kelem,:)=[sum(coordtr(knodes,1))/3  ...
                                          sum(coordtr(knodes,2))/3];
           topp(kelem,:)=[top(ielem,1:3) nnodes+ielem];
       end
       

    elseif (nlnodes==3 & iopt==0),
  
       coordtr(nnodes+ielem,:)=[sum(coord(nodes,1))/3  ...
                                sum(coord(nodes,2))/3];
       toptr(ielem,:)=[nodes nnodes+ielem top(ielem,nlnodes+1)];
    
      

    elseif (nlnodes==4 & iopt==1),

       kelem=kelem+1;
       knodes=nodes([1 2 3]);
       toptr(kelem,:)=[knodes nnodes+kelem top(ielem,nlnodes+1)];
       coordtr(nnodes+kelem,:)=[sum(coord(knodes,1))/3 sum(coord(knodes,2))/3];
       kelem=kelem+1;
       knodes=nodes([1 3 4]);
       toptr(kelem,:)=[knodes nnodes+kelem top(ielem,nlnodes+1)];
       coordtr(nnodes+kelem,:)=[sum(coord(knodes,1))/3 sum(coord(knodes,2))/3];

    elseif (nlnodes==4 & iopt==0),

       kelem=kelem+1;
       knodes=nodes([1 2 3]);
       toptr(kelem,:)=[knodes top(ielem,nlnodes+1)];
       kelem=kelem+1;
       knodes=nodes([1 3 4]);
       toptr(kelem,:)=[knodes top(ielem,nlnodes+1)];

    elseif (nlnodes==9 & iopt==1),

       kelem=kelem+1;
       knodes=nodes([1 2 3 4 5 9]);
       cnodes=nodes([1 3 5]);
       toptr(kelem,:)=[knodes nnodes+kelem top(ielem,nlnodes+1)];
       coordtr(nnodes+kelem,:)=[sum(coord(cnodes,1))/3 sum(coord(cnodes,2))/3];
       kelem=kelem+1;
       knodes=nodes([1 9 5 6 7 8]);
       cnodes=nodes([1 5 7]);
       toptr(kelem,:)=[knodes nnodes+kelem top(ielem,nlnodes+1)];
       coordtr(nnodes+kelem,:)=[sum(coord(cnodes,1))/3 sum(coord(cnodes,2))/3];

    elseif (nlnodes==9 & iopt==0),

       kelem=kelem+1;
       knodes=nodes([1 2 3 4 5 9]);
       cnodes=nodes([1 3 5]);
       toptr(kelem,:)=[knodes top(ielem,nlnodes+1)];
       kelem=kelem+1;
       knodes=nodes([1 9 5 6 7 8]);
       cnodes=nodes([1 5 7]);
       toptr(kelem,:)=[knodes top(ielem,nlnodes+1)];
             

    elseif (nlnodes==6),
        
       map=[1 2 6; 2 3 4; 2 4 6; 4 5 6];
       for i=1:4
           kelem=kelem+1;
           knodes=nodes(map(i,:));
           toptr(kelem,:)=[knodes nnodes+kelem top(ielem,nlnodes+1)];
           coordtr(nnodes+kelem,:)=[sum(coord(knodes,1))/3  ...
                                    sum(coord(knodes,2))/3];
           topp(kelem,1:3)=top(ielem,[1 3 5]);
       end
       
  
    end

end


n=length(toptr(1,:));
toptr=[toptr toptr(:,n)];

top=toptr;
coord=coordtr;


if (ichois==0), return, end

if (ichois==1),
%   origin=[0;0];
   dist=sqrt((coord(:,1)-origin(1)).^2+(coord(:,2)-origin(2)).^2);
elseif (ichois==2),
   dist=sqrt((coord(:,1)).^2);
else
   dist=sqrt((coord(:,2)).^2);
end




% index(i)=j, i=new node number,
%             j=old node number

[dist,index]=sort(dist);
coord=coord(index,:);

if (~isempty(topbnd)),
 [n,m0]=size(topbnd);
 m=m0-1;
 toph=reshape(topbnd(:,1:m),n*m,1);
 ihelp=zeros(n*m,1);
 for i=1:n*m
    ihelp(i)=find(index==toph(i));
 end

 topbnd(:,1:m)=reshape(ihelp,n,m);
end


[n,m0]=size(top);
m=m0-1;
toph=reshape(top(:,1:m),n*m,1);
ihelp=zeros(n*m,1);
for i=1:n*m
    ihelp(i)=find(index==toph(i));
end

top(:,1:m)=reshape(ihelp,n,m);

% renumber topp

if (isempty(topp)~=1),

   [n,m0]=size(topp);
   if (nlnodes==3),
      m=m0;
   else
      m=m0-1;
   end
   toph=reshape(topp(:,1:m),n*m,1);
   ihelp=zeros(n*m,1);
   for i=1:n*m
    ihelp(i)=find(index==toph(i));
   end

   topp(:,1:m)=reshape(ihelp,n,m);

end





% renumber boundary node
ncrvs=length(usercurves(:,1));
for icrv=1:ncrvs
   nodes=nonzeros(usercurves(icrv,:));
   ihelp=zeros(1,length(nodes));
   for i=1:length(nodes)
      ihelp(i)=find(index==nodes(i));
   end
   usercurves(icrv,1:length(nodes))=ihelp;
end

% renumber userpoints
npoints=length(userpoints);
ihelp=zeros(1,npoints);
for i=1:npoints
   ihelp(i)=find(index==userpoints(i));
end
userpoints=ihelp;

if ~isempty(bndcon),
   % renumber boundary conditions
   nodes=bndcon(:,1);
   n=length(nodes);
   for i=1:n
      j=find(index==nodes(i));
      bndcon(i,1)=j;
   end
end


nlnodes=length(top(1,:))-2;
if (nlnodes==7),

   cnodes=top(:,7);
   cnodes1=top(:,1);
   cnodes2=top(:,3);
   cnodes3=top(:,5);
   coord(cnodes,1)=(coord(cnodes1,1)+coord(cnodes2,1)+coord(cnodes3,1))/3;
   coord(cnodes,2)=(coord(cnodes1,2)+coord(cnodes2,2)+coord(cnodes3,2))/3;

   edge=[1 2 3; 3 4 5; 5 6 1];

   for i=1:3
       enodes1=top(:,edge(i,1));
       enodes2=top(:,edge(i,2));
       enodes3=top(:,edge(i,3));
       coord(enodes2,1)=(coord(enodes1,1)+coord(enodes3,1))/2;
       coord(enodes2,2)=(coord(enodes1,2)+coord(enodes3,2))/2;
   end

end
       

% resequence the elements

cnodes=top(:,4);

if (ichois==1),
   dist=sqrt((coord(cnodes,1)-origin(1)).^2+(coord(cnodes,2)-origin(2)).^2);
elseif (ichois==2),
   dist=sqrt((coord(cnodes,1)).^2);
else
   dist=sqrt((coord(cnodes,2)).^2);
end

[dist, loc]=sort(dist);
top=top(loc,:);


