function bndcon=addbndc(bndcon,coord,top,mat,usercurves,crv,dof,string,iplot);
%
% bndcon=addbndc(bndcon,coord,top,mat,usercurves,crv,dof,string,iplot);
%      
% iplot=1: plots the mesh and boundary conditions
%      =0: no-plot
%
% example:
%  prescribe dof 1 on crv 5, 6, 7 to be 1.3:
%    bndcon=[];
%    crv=[5;6;7];
%    dof=1;
%    string='1.3';   (Note the quotes)
%    iplot=1;
%    bndcon=addbndc(bndcon,coord,top,mat,usercurves,crv,dof,string,iplot);
% 
%  prescribe dof 2 on crv 7 and 8 as a function of x:
%    bndcon=[];
%    crv=[7;8];
%    dof=2;
%    iplot=1;
%    string='-x.^2+16';
%    bndcon=addbndc(bndcon,coord,top,mat,usercurves,crv,dof,string,iplot);

nodes=unique(nonzeros(usercurves(crv,:)));
nnodes=length(nodes);

isx=findstr(string,'x');
if ~isempty(isx),
  string=strrep(string,'x','coord(nodes,1)');
end      
      
isy=findstr(string,'y');
if ~isempty(isy),
 string=strrep(string,'y','coord(nodes,2)');
end
      
if isempty(isx) & isempty(isy),
  val=str2num(string)*ones(nnodes,1);
else
  val=eval(string);
end

ndof=length(dof);
for idof=1:ndof
   bndc=[nodes dof(idof)*ones(nnodes,1) val];
   if isempty(bndcon),
      bndcon=bndc;
   else
      bndcon=[bndcon; bndc];
   end
end

if iplot,
   plmesh(coord,top,mat);             
   plbndc(coord,top,mat,bndcon);
end
                       
