function [usercurves,userpoints,usersurfaces,crvtop]=transmesh_crv(usercurves,coord,top,pot,nodnod,ichois);

ncrv=length(usercurves(:,1));


% resequence the usercurves and define the userpoints
userpoints=zeros(1,ncrv*2);
for icrv=1:ncrv
   usercurve=nonzeros(usercurves(icrv,:));
   startnode=transmesh_start(usercurve,top,pot);
   
   usrcrv=zeros(1,length(usercurve));
   usrcrv(1)=startnode;
   k=0;
   n=length(usercurve);
   while k<n-1,
      k=k+1;
      remaining_nodes=setdiff(usercurve,usrcrv(1:k));
      currentnode=usrcrv(k);
      elms=nonzeros(pot(currentnode,:));
      %nods=unique(nonzeros(top(elms,1:maxnlnodes)));
      nods=nonzeros(nodnod(currentnode,:));
      [nxtnode,ia,ib]=intersect(remaining_nodes,nods);      
      usrcrv(k+1)=nxtnode(1);
   end
   usercurves(icrv,1:n)=usrcrv;
   ii=(icrv-1)*2+[1 2];
   userpoints(ii)=usercurves(icrv,[1 n]);
end
userpoints=unique(nonzeros(userpoints));

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype] = sysinfo(size(coord),size(top));

%define the edges
n=length(unique(usercurves));
crvtop=zeros(n,4);
n=0;
k=0;
for icrv=1:ncrv
   nodes=nonzeros(usercurves(icrv,:));
   nnodes=length(nodes);
   if strmatch(ichois,strvcat('qt','eqt')),
      if mod(nnodes,2)==0,
         nodes(nnodes+1)=nodes(1); nnodes=nnodes+1;
      end
      
      ii=1:2:nnodes-1;
      nii=length(ii);
      edge_crv=[nodes(ii) nodes(ii+1) nodes(ii+2) icrv*ones(nii,1) ones(nii,1) ];
      
   elseif strmatch(ichois,strvcat('lt','elt')),
      ii=1:nnodes-1;
      nii=length(ii);
      edge_crv=[nodes(ii) nodes(ii+1) icrv*ones(nii,1) ones(nii,1)];
   end
   
   %check for the orientation of the element
   elms1=nonzeros(pot(edge_crv(1,1),:));
   elms2=nonzeros(pot(edge_crv(1,2),:));
   [c,ia,ib]=intersect(elms1,elms2);
   if length(c)==1,
      lnodes=top(c,1:maxnlnodes);
      xymid=mean(coord(lnodes,:));
      
      node1=edge_crv(1,1);
      node2=edge_crv(1,2);
      
      a=[xymid(1)-coord(node1,1); xymid(2)-coord(node1,2); 0];
      b=[coord(node2,1)-coord(node1,1) ; coord(node2,2)-coord(node1,2); 0];
      
      c=cross(a,b);
      
      if c(3)>0,
         % reverse the order of the element
         if length(edge_crv)==5,
            edge_crv(:,1:3)=edge_crv(:,3:-1:1);
         elseif length(edge_crv)==4,
            edge_crv(:,1:2)=edge_crv(:,[2 1]);
         end
      end
      
   end
   
      
      
   
   [n,m]=size(edge_crv);
   crvtop(k+1:k+n,1:m)=edge_crv;
   k=k+n;
end
crvtop=crvtop(1:k,1:m);

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype] = sysinfo(size(coord),size(top));

surf=unique(top(:,iitype));
nsurf=max(surf);
for isurf=1:nsurf
   ii=find(top(:,iitype)==isurf);
   if ~isempty(ii),      
      n=length(ii);
      usersurfaces(isurf,1:n)=ii(:)';
   end
end
