
function [nodnod]=transmesh_nodpot(coord,top,pot,elgraph);
%
% [nodnod]=transmesh_nodpot(coord,top,pot,elgraph);
%
% Input:
%  top       : topology
%  pot		 : inverse topology
%  elgraph   : element connectivity
%  
% Output:
%  nodnod    : nodnod(inode,:) : nodes connected to inode, based upon elgraph
%

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype] = sysinfo(size(coord),size(top));

%pot=toppot(top);

nodnod=zeros(nnodes,maxnlnodes*3);

nmax=0;

for inode=1:nnodes
    
    elms=nonzeros(pot(inode,:));
    
    k=0;
    for i=1:length(elms);
    
        ielem   = elms(i);
        %elgraph = eleminfo(ielem,coord,top,mat,3);
        nodes   = top(ielem,elgraph(:,1));
        nlnodes = length(nodes);
       
        ii=find(nodes==inode);
        
        if ~isempty(ii)
        
           ii=ii+1;
           nodes=[nodes(nlnodes) nodes nodes(1)];
        
           nodnod(inode,k+1)=nodes(ii-1);
           nodnod(inode,k+2)=nodes(ii+1);
           
           k=k+2;
          
        end
        
        
     end
     
     nodes=unique(nonzeros(nodnod(inode,:)));
     nlnodes=length(nodes);
     if nlnodes~=0, nodnod(inode,1:nlnodes)=nodes'; end
     
     if nlnodes>nmax, nmax=nlnodes; end
     
end


nodnod=nodnod(:,1:nmax);


