function  [c,ix,iy]=findcomm(x,y)
% FINDCOMM  [c,ix,iy] = findcomm(x,y)
%
% finds the elements that vector x and y have in common
% x : vector
% y : vector
% c : column vector with common elements
% ix: indices in x =>   c=x(ix) 
% iy: indices in y =>   c=y(iy) 

% file           : yesno.m
% last change    : 23 november 1994
% author         : P.Wortelboer
% used functions : rowsum

x=x(:);
y=y(:).';
nx=length(x);
ny=length(y);
X=x(:,ones(1,ny));
Y=y(ones(1,nx),:);
I=(X==Y);
ix=(rowsum(I)>0);
iy=(sum(I)>0)';
c=x(ix);

% Copyright Philips Research Labs, 1994,  All Rights Reserved
