function [xp,yp,xylevel,hlines]=cntr(coord,top,mat,data,clevel,ccolor,hf,option)
%
%
% modifications:
%  20-01-98  : hlines initialized to []
%

if nargin<8, option=zeros(10,1); end


    

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype] = sysinfo(size(coord),size(top));


ncolors = length(ccolor);
nlevel  = length(clevel);


k=0;

elgraph = eleminfo(1,coord,top,mat,3);
ntriang = length(elgraph(:,1));
nedge   = ntriang*nelem;

xx   = zeros(3,ceil(1.5*nedge));   %* 1.5 is safety margin
yy   = xx;
a    = xx;

l=0;

set(hf,'name','Computing the contours','numbertitle','off'); pause(.1);
for ielem=1:nelem

   nlnodes  = length(nonzeros(top(ielem,1:maxnlnodes)));
   nodes    = top(ielem,1:nlnodes); 
   nodcoord = coord(nodes,:);
   nodcoord(nlnodes+1,:) = mean(nodcoord(1:nlnodes,:));

   dat      = data(ielem,1:nlnodes)';
   
   dat(nlnodes+1) = mean(dat);
    
   elgraph = eleminfo(ielem,coord,top,mat,3);

   lnodes=unique(elgraph);
   nlnodes=length(lnodes);

   split=[elgraph (nlnodes+1)*ones(nlnodes,1)];

   nsplit=length(split(:,1));

   for i=1:nsplit
       l=l+1;
       pnts=split(i,:)';
       a(:,l)=dat(pnts);
       xx(:,l)=nodcoord(pnts,1);
       yy(:,l)=nodcoord(pnts,2);
   end
   
end

a  = a(:,1:l);
xx = xx(:,1:l);
yy = yy(:,1:l);

s=nan*ones(3,l);

n=0; m=0;
xp      = zeros(2,l);
yp      = xp;
xylevel = zeros(1,l);


edge=[1 2; 2 3; 3 1];
for ilevel=nlevel:-1:1

    %* first edge
    ii=find(a(2,:)-a(1,:));
    s(1,ii)=(clevel(ilevel)-a(1,ii))./(a(2,ii)-a(1,ii));
    
    
    %* second edge
    ii=find(a(3,:)-a(2,:));
    s(2,ii)=(clevel(ilevel)-a(2,ii))./(a(3,ii)-a(2,ii)); 
    
       
    %* third edge
    ii=find(a(1,:)-a(3,:));
    s(3,ii)=(clevel(ilevel)-a(3,ii))./(a(1,ii)-a(3,ii));
    
    for i=1:3
        iedge=edge(i,1);
        jedge=edge(i,2);
        ii=find(s(iedge,:)>=0 & s(iedge,:)<=1);
        jj=find(s(jedge,:)>=0 & s(jedge,:)<=1);
        
        if ~isempty(ii) & ~isempty(jj)
        
         [c,ix,iy]=findcomm(ii,jj);
         kk=find(ix);
         ii=ii(kk);
        
         if ~isempty(ii)
        
           npnt=length(ii);
           xpnt=zeros(2,npnt);
           ypnt=xpnt;
        
           noda1=edge(iedge,1);
           noda2=edge(iedge,2);
           nodb1=edge(jedge,1);
           nodb2=edge(jedge,2); 
                  
           xpnt(1,:)=(1-s(iedge,ii)).*xx(noda1,ii)+s(iedge,ii).*xx(noda2,ii);
           xpnt(2,:)=(1-s(jedge,ii)).*xx(nodb1,ii)+s(jedge,ii).*xx(nodb2,ii);
        
           ypnt(1,:)=(1-s(iedge,ii)).*yy(noda1,ii)+s(iedge,ii).*yy(noda2,ii);
           ypnt(2,:)=(1-s(jedge,ii)).*yy(nodb1,ii)+s(jedge,ii).*yy(nodb2,ii);
           
           xp(:,n+1:n+npnt)      = xpnt;
           yp(:,n+1:n+npnt)      = ypnt;
           xylevel(:,n+1:n+npnt) = clevel(ilevel)*ones(1,npnt);
           n                     = n+npnt;
                  
         end
        
       end
        
    end

end

%resize
xp      = xp(:,1:n);
yp      = yp(:,1:n);
xylevel = xylevel(1:n);
            

hlines=[];
i=0;
for ilevel=1:nlevel
    ii=find(xylevel==clevel(ilevel));
    hline=line(xp(:,ii),yp(:,ii),'color',ccolor(ilevel,:));
    if ~isempty(hlines),
       hlines=[hlines(:); hline(:)];
    else
       hlines=hline(:);
    end
    if ~isempty(hline)
       i=i+1;
       hl(i)=hline(1);
       string=num2str(clevel(ilevel));
       n=length(string);
       strmat(i,1:n)=string; 
    end  
end


%* plot the legend, if option(1)<0
if option(1)>0,

   set(hf,'name','Creating the legend','numbertitle','off'); pause(.1);

   fs=get(gca,'fontsize');
   set(gca,'fontsize',1)
   coleg(hl',strmat,ccolor);
   %legend(hl',strmat,-1)

   %hl=colegend(hl',strmat,-1);
   set(gca,'fontsize',fs);
   
end


set(hf,'name','almost ready, bye,bye','numbertitle','off');


% plot minimum and maximum

[x,i]=min(data); [y,j]=min(x);
cmin=data(i(j),j);
k_min=i(j); l_min=j;

[x,i]=max(data); [y,j]=max(x);
cmax=data(i(j),j);
k_max=i(j); l_max=j;

x_min=coord(top(k_min,l_min),1);
y_min=coord(top(k_min,l_min),2);

x_max=coord(top(k_max,l_max),1);
y_max=coord(top(k_max,l_max),2);

plot(x_min,y_min,'ow');
plot(x_max,y_max,'xw');

%[cmin,imin]=min(xylevel(2:length(xylevel)));
%[cmax,imax]=max(xylevel(2:length(xylevel)));

%plot(xp(1,imin+1), yp(1,imin+1),'ow');
%plot(xp(1,imax+1), yp(1,imax+1),'xw');

%h=pldot([xp(1,imin+1), yp(1,imin+1)],ccolor(1)); set(h,'edgecolor','w');
%h=pldot([xp(1,imax+1), yp(1,imax+1)],ccolor(ncolors)); set(h,'edgecolor','w');
hold off;

lab=[ ' (o) min: ' num2str(cmin),   ...
      ' (x) max: ' num2str(cmax)];
title(lab)



