function covalues(xp,yp,xylevel)
%
%  covalues(xp,yp,xylevel);
%
% places values of the contourlines definid by conoddat and coelmdat at
% select positions.
%
% input
%   xp      : x coordinates of contour line segments, see conoddat
%   yp      : y coordinates of contour line segmetns
%   xylevel : contourlevels
%

hf=gcf;

n=get(hf,'name');
n=get(hf,'numbertitle');

ax = get(gcf,'children');

if ~isempty(ax), 
   axis_found = 1;

   
  if (length(ax)>1),
      set(hf,'name','define axis by clicking on figure ',...
             'numbertitle','off')
  end
  
end

set(hf,'name',...
       'select position to put labels by clicking on lines, button 3: stop',...
       'numbertitle','off');
       
       

hold on
button=1;
xmax=max(xp);
xmin=min(xp);
ymax=max(yp);
ymin=min(yp);
dif=min([xmax-xmin ymax-ymin]);
while (button~=3),
  [x,y,button]=ginput(1);
  if (button~=3),
   dist=sqrt((xp(1,:)-x).^2+(yp(1,:)-y).^2);
   [dist,index]=sort(dist);
   inode=index(1);
   text(xp(1,inode),...
        yp(1,inode),'+');
   text(x+0.01*dif,...
        y+0.01*dif,num2str(xylevel(inode)) );
   plot([xp(1,inode)-0.01*dif;xp(1,inode)+0.01*dif],...
        [yp(1,inode)         ;yp(1,inode)         ],'-w');
   plot([xp(1,inode)         ;xp(1,inode)         ],...
        [yp(1,inode)-0.01*dif;yp(1,inode)+0.01*dif],'-w');
  end
end

hold off
set(hf,'name',n,'numbertitle',n)

