function h = plarrow3(x,y,z,dx,dy,dz,double,color)

% h = plarrow3(x,y,z,dx,dy,dz,double,color)

if nargin == 6
   double = 0;
   color  = 'g';
elseif nargin == 7
   color  = 'g';
end

headlengthratio = 0.2;
headwidthratio  = 0.1;

ax = axis;
scalexy = ( ax(2)-ax(1) ) / ( ax(4)-ax(3) );  
scalexz = ( ax(2)-ax(1) ) / ( ax(6)-ax(5) );  
scaleyz = ( ax(4)-ax(3) ) / ( ax(6)-ax(5) );  

xtop = x+dx; ytop = y+dy; ztop = z+dz;
xh   = x+(1-headlengthratio).*dx;
yh   = y+(1-headlengthratio).*dy;
zh   = z+(1-headlengthratio).*dz;
dxh = headwidthratio.*dy*scalexy;
dyh = headwidthratio.*dx;
dzh = 0;
%dxh2 = headwidthratio.*dz*scalexz;
dxh2 = 0;
dyh2 = 0;
%dzh2 = headwidthratio.*dx;
dzh2 = 0;


h0 = line([x xtop (xh-dxh) (xh+dxh) xtop (xh-dxh2) (xh+dxh2) xtop]', ...
          [y ytop (yh-dyh) (yh+dyh) ytop (yh-dyh2) (yh+dyh2) ytop]', ...
          [z ztop (zh-dzh) (zh+dzh) ztop (zh-dzh2) (zh+dzh2) ztop]', ...
           'Color',color); 

if double
   xh2  = x+(1-2*headlengthratio).*dx;
   yh2  = y+(1-2*headlengthratio).*dy;
   zh2  = z+(1-2*headlengthratio).*dz;
   h1 = line([xh (xh2-dxh) (xh2+dxh) xh (xh2-dxh2) (xh2+dxh2) xh]', ...
             [yh (yh2-dyh) (yh2+dyh) yh (yh2-dyh2) (yh2+dyh2) yh]', ...
             [zh (zh2-dzh) (zh2+dzh) zh (zh2-dzh2) (zh2+dzh2) zh]', ...
              'Color',color); 
   h0 = [ h0 ; h1 ];   
end

if nargout>0
   h = h0;
end


