function plbound(coord,top,mat,colorstyle)

% plots boundary of 2d mesh,
% 
% h = plbound(coord,top,mat);
% h = plbound(coord,top,mat,colorstyle);
%
% input:
%   coord             : nodal coordinates
%   top               : element topology
%   mat               : material parameters
%   colorstyle ('y-') : style and color i.e. 'y-' (optional)


if nargin<3
   mat=[];
end
if nargin<4
   colorstyle='y-';
end

color = colorstyle(1);
style = colorstyle(2:length(colorstyle));

holdstate = get(gca,'nextplot');
set(gca,'nextplot','add')

a = top2grph(coord,top,mat);

hold on
gplot(a-a',coord,colorstyle); 

hold off

set(gca,'nextplot',holdstate)

