function h = pldofnum(coord,dest);
% plots the numbers of the dofs in the current meshplot
%
% h = pldofnum(coord,dest);
%
% input:
%   coord        : nodal coordinates
% 	dest  	     : destination array


if (nargin==1), color='y'; end

[nnodes,nsd]=size(coord);

h0 = zeros(nnodes,1);

if nsd==2

   for inode=1:nnodes

       dofs=nonzeros(dest(inode,:));
       string=mat2str(dofs);
       h0(inode) = text(coord(inode,1),coord(inode,2),string);
       set(h0(inode),'horiz','cent');

   end

elseif nsd==3

   for inode=1:nnodes

       dofs=nonzeros(dest(inode,:));
       string=mat2str(dofs);
       h0(inode) = text(coord(inode,1),coord(inode,2),coord(inode,3),...
                      string);
       set(h0(inode),'horiz','cent');

   end

end

if nargout>0
   h = h0;
end
