function h=pldot(xmid,color,perc)
%
% h=pldot(xmid,color,perc)
%
% this function adds a dot with color to a plot
%
% Input :    
%  xmid        : midpoint postion of dot
%  color ('w') : color of dot
%  perc  (1.5) : radius of dot in percentage of maximum axis length
%

if nargin<2,
   color='w';
end
if nargin<3,
   perc=1.5;
end


%* get the axis limits
ha=gca;
xlim=get(ha,'xlim');
ylim=get(ha,'ylim');

xl  = xlim(2)-xlim(1);
yl  = ylim(2)-ylim(1);

xyl = max([xl yl]); 

%* set the radius of the dot
radius=perc*xyl/100;

%* initial point to sweep around
x0=[radius;0];

%* n: number of point defining the polygon
n=30;
fie0=0; fien=2*pi;
fie=fie0;
dfie=(fien-fie0)/(n-1);

%* initialize points on polygon
coordb=zeros(n,2);
coordb(1,:)=x0';

%* compute the polygon
for i=1:n
    rot=[cos(fie) -sin(fie);
         sin(fie)  cos(fie)];

    coordb(i,:)=(rot*x0)';

    fie=fie+dfie;
end

%* translate the polygon
coordb(:,1)=coordb(:,1)+xmid(1);
coordb(:,2)=coordb(:,2)+xmid(2);


if ~isstr(color),
   color=color*ones(n,1);
end

%* plot the polygon
h=patch(coordb(:,1),coordb(:,2),color);

