function plelgrp(coord,top,mat,ichois)
%
% plelgrp(coord,top,mat,ichois);
%
% input: 
%   coord       : nodal coordinates
%   top         : topology
%   mat         : material properties
%   ichois  (1) : 1 - (default) material groups
%               : 2 - element type groups
%
%

if nargin<3
   mat=[];
end

if nargin<4
   ichois=1;
end


[nnodes,nsd,nelem,maxnlnodes,iimat,iitype]=sysinfo(size(coord),size(top));

if (ichois==1),
   grps = unique(top(:,iimat));
   ipnt = iimat;
elseif (ichois==2),
   grps = unique(top(:,iitype));
   ipnt = iitype;
else
   error(['Ichois = ' num2str(ichois) ' not supported']);
end


ngrp = length(grps);

plmesh(coord,top,mat);

colors = ['y';'m';'c';'r';'g';'b';'w'];

colors = jet;
ncolor = length(colors(:,1));
dcolor = floor(ncolor/ngrp);
colors = flipud(colors(ncolor:-dcolor:1,:));



   
for i=1:ngrp
        
    igrp=grps(i);
       
    ii=find(top(:,ipnt)==igrp);
       
    plelem(coord,top(ii,:),mat,colors(i,:),'f');
       
 end
 
 