function h = plelnum(coord,top);

% add element numbers of the elements represented by top
%
% h = plelnum(coord,top);
%
% input:
%   coord        : nodal coordinates
%   top          : element topology


if nargin<2
   error('Too few input arguments, must be at leat 2');
end

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype]=sysinfo(size(coord),size(top));

h0 = zeros(nelem,1);

if nsd==2

  for ielem=1:nelem

    nlnodes=length(nonzeros(top(ielem,1:maxnlnodes)));
    x=mean(coord(top(ielem,1:nlnodes),:));
    h0(ielem) = text(x(1),x(2),[num2str(ielem)]);
    set(h0(ielem),'color','r');

  end

elseif nsd==3

  for ielem=1:nelem

    nlnodes=length(nonzeros(top(ielem,1:maxnlnodes)));
    x=mean(coord(top(ielem,1:nlnodes),:));
    h0(ielem) = text(x(1),x(2),x(3),[num2str(ielem)]);

  end

end

if nargout>0
   h = h0;
end
