function h = plnodes(coord,color,style);

% plots nodes
%
% h = plnodes(coord)
% h = plnodes(coord,color,style);
%
% input:
%   coord        : nodal coordinates
%   color        : color of the nodes i.e. 'y' (optional)
%   style        : style of the nodes i.e. 'o' (optional)
  
[nnodes,nsd] = size(coord);
if nargin<2
   color = 'y';
end
if nargin<3
   style = 'o';
end


if nsd==2

   x = coord(:,1);
   y = coord(:,2);
   h0 = line(x,y,'linestyle','none','marker',style,'color',color);

else

   x = coord(:,1);
   y = coord(:,2);
   z = coord(:,3);
   h0 = line(x,y,z,'linestyle','none','marker',style,'color',color);

end

if nargout>0
   h = h0;
end
