function h = plnodnum(coord);
% plots the numbers of the nodes in the current meshplot
%
% h = plnodnum(coord);
%
% input:
%   coord        : nodal coordinates


if (nargin==1), color='y'; end

[nnodes,nsd]=size(coord);

h0 = zeros(nnodes,1);

if nsd==2

   for inode=1:nnodes

       h0(inode) = text(coord(inode,1),coord(inode,2),[num2str(inode)]);

   end

elseif nsd==3

   for inode=1:nnodes

     h0(inode) = text(coord(inode,1),coord(inode,2),coord(inode,3),...
                      [num2str(inode)]);

   end

end

if nargout>0
   h = h0;
end
