function h = plusrpts(usrp,coord,color,style,labels)

%
% h = plusrpts(usrp,coord,color,style,labels);
%
%
% plots user curves in a 2D mesh
%
% COORD      : nodal point coordinates
% USRPTS     : nodal points indexes of nodes on user points
% LABELS     : (optional) choice paramater, indicating if point 
%              labels must be plotted (1) or not (0). Default = 1 
%
% plot function

if nargin<4
   labels = 1;
end
if nargin<3
   color='r'; style='o';
end
if nargin<4, 
   style='o';
end

nsd = length(coord(1,:));

h0 = [];

%** userpoints
usrp = nonzeros(usrp);
if ~isempty(usrp),
   nusrp = length(usrp);
   upcoord = coord(usrp,:);
   h1 = line(upcoord(:,1),upcoord(:,2),'linestyle','none','Marker',style,'Color',color);
   h0 = [ h0 ; h1 ];
   if labels
     for iusrp=1:nusrp
       text(upcoord(iusrp,1),upcoord(iusrp,2), [ 'P' num2str(iusrp) ])
     end
   end
end

if nargout>0
   h = h0;  
end

