function [A] = top2grph(coord,top,material)

% A = top2grph(coord,top,material);
%
% creates a graph A from the mesh connectivity
%
%
% plot function

if isempty(top)
   A = [];
   return
end;
if nargin<3
    material=[];   
end

[nnodes,nsd,nelem,maxnlnodes,iimat,iitype] = sysinfo(size(coord),size(top));

A = spalloc(nnodes,nnodes,nelem*maxnlnodes);

for ielem = 1:nelem

    if ~isempty(material)    
%       itype   = top(ielem,iitype);  
%       routine = unblank([elnames(itype,:) '_info']);
%       [ldof,elgraph] = feval(routine,ielem,coord,top);    
       ldof    = eleminfo(ielem,coord,top,material,1);
       elgraph = eleminfo(ielem,coord,top,material,3);
       nlnodes = length(ldof);
    else
       elgraph = [];
       if mod(maxnlnodes,2) & maxnlnodes>3, maxnlnodes=maxnlnodes-1; end
       nlnodes = length(find(top(ielem,1:maxnlnodes)));       
    end
    
    if nlnodes<2
    
       %** point, do nothing

    elseif isempty(elgraph) 

       %** straight forward nodal connectivity 
       i1 =  find(top(ielem,1:nlnodes)>0); nln = length(i1);
       i2 = [ i1(2:nln) i1(1) ];
       node1 = top(ielem,i1);
       node2 = top(ielem,i2);
       for iln = 1:nln
           A(node1(iln),node2(iln)) = 1;
       end

     else

       %** deviating plot connectivity
       i1    = elgraph(:,1);
       i2    = elgraph(:,2);
       nln   = length(i1);
       node1 = top(ielem,i1);
       node2 = top(ielem,i2);
       for iln = 1:nln
           A(node1(iln),node2(iln)) = 1;
       end

     end

end;

