function pot = toppot(top)

% pot = toppot(top);
%
% generates an inverse topology array
%
% TOP = topology array. TOP(IELEM,:) contains global node indices
%       of element IELEM 
%       
% POT = inverse topology array POT(INODE,:) contains element indices of elements
%       that contain node INODE
%

[nsd,nnodes,nelem,maxnlnodes,iimat,iitype] = sysinfo([0 0],size(top));
nnodes = max(max(top(:,1:maxnlnodes)));    

pot = zeros(nnodes,1);  %** inverse topology array
num = zeros(nnodes,1);  %** number of elements per node 

for ielem = 1:nelem
  for ilnode = 1:maxnlnodes
      node = top(ielem,ilnode);
      if (node>0)
         num(node) = num(node)+1;
         pot(node,num(node)) = ielem;
      end
  end
end

